// Devay - song bitrate/freq/track number

#include "../../../lib/std.mi"

Function string tokenizeSongInfo(String tkn, String sinfo);
Function String getTrackNumber();

Global Text bitrateText, infolineExampleText, FrequencyText, abrText, Songticker, TrackText;
Global group Main;
Global Timer songInfoTimer;
Global String SongInfoString;

System.onScriptLoaded(){
  Group displaygroup = getContainer("main").getLayout("normal").getObject("display-group");
  infolineExampleText = displaygroup.getObject("infoline");
  bitrateText = displaygroup.getObject("Bitrate");
  frequencyText = displaygroup.getObject("Frequency");
  TrackText = displaygroup.getObject("Track");
  Songticker = displaygroup.getObject("Songticker");

  songInfoTimer = new Timer;
  songInfoTimer.setDelay(1000);
  if (getLeftVUMeter()!=null) songInfoTimer.start();
}

System.onScriptUnloading(){
	delete songInfoTimer;
}

System.onPlay(){
	songInfoTimer.start();
}

System.onStop(){
	songInfoTimer.stop();
}

System.onResume(){
	songInfoTimer.start();
}

System.onPause(){
	songInfoTimer.stop();
}


infolineExampleText.onTextChanged(String newtxt) {
  if(newtxt=="-") {
    infolineExampleText.setText("");
	return;
  }
  String tkn, songinfo;
  songinfo = strupper(newtxt);
}

songInfoTimer.onTimer(){
String tkn;
	SongInfoString = infolineExampleText.getText();

	tkn = tokenizeSongInfo("Bitrate", SongInfoString);
	if(tkn != "") {bitrateText.setText(tkn);}

	tkn = tokenizeSongInfo("Frequency", SongInfoString);
	if(tkn != "") {frequencyText.setText(tkn);}

	TrackText.setText(getTrackNumber());
}

tokenizeSongInfo(String tkn, String sinfo){
    int searchResult;
    String rtn;
if (tkn=="Bitrate"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "kbps");
			if (searchResult>0) return Strleft(rtn, 3);
		}
		return "";
}

if (tkn=="Frequency"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(strlower(rtn), "khz");
			if (searchResult>0) return Strleft(rtn, 2);
		}
		return "";
}
if (tkn=="ABR"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "bps)");
			if (searchResult>0) return rtn;
		}
		return "";
}


else return "";
}  

//Track no. by rpc
getTrackNumber() {
    String strTitle = Songticker.getText();
    Int intTrackIndex = System.StringToInteger(System.StrLeft(strTitle, System.StrSearch(strTitle, ".")));
    String strTrackIndex = System.IntegerToString(intTrackIndex);
    return strTrackIndex;
}